Grid Context Menu

Grid for React

React version of this topic (compatible with React 19+). Keep the same configuration logic from JavaScript and pass it as component props.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

import React, { useMemo, useRef } from 'react';
import { Grid } from 'smart-webcomponents-react/grid';
import 'smart-webcomponents-react/source/styles/smart.default.css';

export default function App() {
  const componentRef = useRef(null);
  const componentProps = useMemo(() => ({
    // Copy this topic's JavaScript configuration here.
  }), []);

  return <Grid ref={componentRef} {...componentProps}></Grid>;
}

Use componentRef.current for API methods in this topic.

Grid Context Menu

Default Context Menu

A built-in context menu is available in the Grid component. To enable the default context menu, you can use the contextMenu property.
const componentProps = {
    dataSourceSettings: {
        dataFields: [
            { name: 'firstName', dataType: 'string' },
            { name: 'lastName', dataType: 'string' },
            { name: 'productName', map: 'product.name', dataType: 'string' },
            { name: 'payment', map: 'product.payment', dataType: 'string' },
            { name: 'quantity', map: 'product.quantity', dataType: 'number' },
            { name: 'price', map: 'product.price', dataType: 'number' },
            { name: 'total', map: 'product.total', dataType: 'number' }
        ]
    },
    editing: {
        enabled: true
    },
    selection: {
        enabled: true,
        allowCellSelection: true,
        mode: 'extended'
    },
    contextMenu: {
        enabled: true
    },
    filtering: {
        enabled: true
    },
    behavior: {
        columnResizeMode: 'growAndShrink'
    },
    sorting: {
        enabled: true
    },
    dataSource: [
        {
            firstName: 'Andrew',
            lastName: 'Burke',
            product: {
                name: 'Ice Coffee', price: 10, quantity: 3, total: 30, payment: 'Visa'
            }
        },
        {
            firstName: 'Petra',
            lastName: 'Williams',
            product: {
                name: 'Espresso', price: 7, quantity: 5, total: 35, payment: 'Visa'
            }
        },
        {
            firstName: 'Anthony',
            lastName: 'Baker',
            product: {
                name: 'Frappucino', price: 6, quantity: 4, total: 24, payment: 'Mastercard'
            }
        }
    ],
    columns: [
        {
            label: 'First Name', dataField: 'firstName'
        },
        { label: 'Last Name', dataField: 'lastName' },
        { label: 'Product', dataField: 'productName' },
        {
            label: 'Quantity', dataField: 'quantity', cellsAlign: 'right'
        },
        {
            label: 'Unit Price', dataField: 'price', cellsAlign: 'right', cellsFormat: 'c2'
        },
        {
            label: 'Last Updated', template: 'updatedDate', dataType: 'date', allowEdit: false
        },
        {
            label: 'Created', template: 'createdDate', dataType: 'date', allowEdit: false
        }
    ]
}
		
grid context menu

Custom Item

You can setup a custom menu item.
contextMenu: {
	enabled: true,
	dataSource: {
		'contextMenuItemCustom': {
			label: 'Custom Item',
			visible: true,
			command: (details) => {
				// your command code here.
			}
		}
	}
}

grid custom context menu

Binding to Context menu

If there is already a context menu on the web page, or you want to override the built-in Grid context menu, you can set the contextMenu.selector property.
const componentProps = {
    dataSourceSettings: {
        dataFields: [
            { name: 'firstName', dataType: 'string' },
            { name: 'lastName', dataType: 'string' },
            { name: 'productName', map: 'product.name', dataType: 'string' },
            { name: 'payment', map: 'product.payment', dataType: 'string' },
            { name: 'quantity', map: 'product.quantity', dataType: 'number' },
            { name: 'price', map: 'product.price', dataType: 'number' },
            { name: 'total', map: 'product.total', dataType: 'number' }
        ]
    },
    editing: {
        enabled: true
    },
    selection: {
        enabled: true,
        allowCellSelection: true,
        mode: 'extended'
    },
    contextMenu: {
        enabled: true,
        selector: "#menu"
    },
    filtering: {
        enabled: true
    },
    behavior: {
        columnResizeMode: 'growAndShrink'
    },
    sorting: {
        enabled: true
    },
    dataSource: [
        {
            firstName: 'Andrew',
            lastName: 'Burke',
            product: {
                name: 'Ice Coffee', price: 10, quantity: 3, total: 30, payment: 'Visa'
            }
        },
        {
            firstName: 'Petra',
            lastName: 'Williams',
            product: {
                name: 'Espresso', price: 7, quantity: 5, total: 35, payment: 'Visa'
            }
        },
        {
            firstName: 'Anthony',
            lastName: 'Baker',
            product: {
                name: 'Frappucino', price: 6, quantity: 4, total: 24, payment: 'Mastercard'
            }
        }
    ],
    columns: [
        {
            label: 'First Name', dataField: 'firstName'
        },
        { label: 'Last Name', dataField: 'lastName' },
        { label: 'Product', dataField: 'productName' },
        {
            label: 'Quantity', dataField: 'quantity', cellsAlign: 'right'
        },
        {
            label: 'Unit Price', dataField: 'price', cellsAlign: 'right', cellsFormat: 'c2'
        }
    ]
}
HTML for grid and menu.
<smart-grid id="grid"></smart-grid>
<smart-menu id="menu" mode="dropDown">
	<smart-menu-item data-id="Edit" label="<i class='material-icons'>edit</i>Edit"></smart-menu-item>
	<smart-menu-item data-id="Remove" label="<i class='material-icons'>delete</i> Remove"></smart-menu-item>
</smart-menu>	
and the CSS for the context menu
#menu {
    height: auto;
	width: 150px;
}

@font-face {
	font-family: 'Material Icons';
	font-style: normal;
	font-weight: 400;
	src: url(https://fonts.gstatic.com/s/materialicons/v31/2fcrYFNaTjcS6g4U3t-Y5ZjZjT5FdEJ140U2DJYC3mY.woff2) format('woff2');
}

.material-icons {
	font-family: 'Material Icons';
	font-weight: normal;
	font-style: normal;
	font-size: 20px;
	line-height: 1;
	letter-spacing: normal;
	text-transform: none;
	display: inline-block;
	white-space: nowrap;
	word-wrap: normal;
	direction: ltr;
	-webkit-font-feature-settings: 'liga';
	-webkit-font-smoothing: antialiased;
	margin-right: 10px;
}
context menu selector

Custom Context Menu

You can use a custom Menu instance as a context menu. Let's see how we can achieve that.
HTML for grid and menu.
<smart-grid id="grid"></smart-grid>
<smart-menu id="menu" mode="dropDown">
	<smart-menu-item data-id="Edit" label="<i class='material-icons'>edit</i>Edit"></smart-menu-item>
	<smart-menu-item data-id="Remove" label="<i class='material-icons'>delete</i> Remove"></smart-menu-item>
</smart-menu>	
The following code shows how to open and handle the actions of the custom menu.
const menu = document.getElementById('menu');
let rowId = null;
// disable the browser's context menu and open the custom menu.
componentRef.current.addEventListener('contextmenu', function (event) {
	event.stopPropagation();
	event.preventDefault();
	menu.open(event.pageX, event.pageY);
	return false;
});
// handle the clicks of the custom menu.
menu.addEventListener('itemClick', function (event) {
	if (rowId === undefined) {
		return;
	}
	if (event.detail.item.getAttribute('data-id') === 'Edit') {
		componentRef.current.beginEdit(rowId);
	}
	else {
		componentRef.current.deleteRow(rowId);
	}
});
// disable the built-in right-click.
componentRef.current.addEventListener('rowClick', function (event) {
	if (event.detail.originalEvent.which === 3) {
		const row = event.detail.row;
		rowId = row.id;
		event.detail.originalEvent.stopPropagation();
	}
});
grid custom context menu
For AI tooling

Developer Quick Reference

Topic: grid-context-menu   Component: Grid   Framework: React

Main methods: addEventListener(), beginEdit(), deleteRow()

Common config keys: editing, selection, filtering, behavior, sorting, dataSource, columns

Implementation Notes

Compatibility: React 19+   API access pattern: const componentRef = useRef(null) + componentRef.current.method()

Lifecycle guidance: Use useMemo for large config objects and call imperative API through componentRef.current after first render.

Common pitfalls:

  • Recreating columns/dataSource objects on every render can reset component state.
  • Calling API methods before ref is available causes runtime errors.
  • Mixing controlled and imperative updates without sync can lead to stale UI.

Validation checklist:

  • Keep config objects memoized when possible.
  • Guard API calls with ref existence checks.
  • Verify CSS theme import is present once per app.

Grid Context Menu

Grid for Vue

Vue 3 version using Smart custom elements and template refs.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

<script setup>
import { onMounted, ref } from 'vue';
import 'smart-webcomponents/source/styles/smart.default.css';
import 'smart-webcomponents/source/modules/smart.grid.js';

const component = ref();
const componentProps = {
  // Copy this topic's JavaScript configuration here.
};

onMounted(() => {
  Object.assign(component.value, componentProps);
});
</script>

<template>
  <smart-grid ref="component"></smart-grid>
</template>

Use component.value for API methods in this topic.

Grid Context Menu

Default Context Menu

A built-in context menu is available in the Grid component. To enable the default context menu, you can use the contextMenu property.
const componentProps = {
    dataSourceSettings: {
        dataFields: [
            { name: 'firstName', dataType: 'string' },
            { name: 'lastName', dataType: 'string' },
            { name: 'productName', map: 'product.name', dataType: 'string' },
            { name: 'payment', map: 'product.payment', dataType: 'string' },
            { name: 'quantity', map: 'product.quantity', dataType: 'number' },
            { name: 'price', map: 'product.price', dataType: 'number' },
            { name: 'total', map: 'product.total', dataType: 'number' }
        ]
    },
    editing: {
        enabled: true
    },
    selection: {
        enabled: true,
        allowCellSelection: true,
        mode: 'extended'
    },
    contextMenu: {
        enabled: true
    },
    filtering: {
        enabled: true
    },
    behavior: {
        columnResizeMode: 'growAndShrink'
    },
    sorting: {
        enabled: true
    },
    dataSource: [
        {
            firstName: 'Andrew',
            lastName: 'Burke',
            product: {
                name: 'Ice Coffee', price: 10, quantity: 3, total: 30, payment: 'Visa'
            }
        },
        {
            firstName: 'Petra',
            lastName: 'Williams',
            product: {
                name: 'Espresso', price: 7, quantity: 5, total: 35, payment: 'Visa'
            }
        },
        {
            firstName: 'Anthony',
            lastName: 'Baker',
            product: {
                name: 'Frappucino', price: 6, quantity: 4, total: 24, payment: 'Mastercard'
            }
        }
    ],
    columns: [
        {
            label: 'First Name', dataField: 'firstName'
        },
        { label: 'Last Name', dataField: 'lastName' },
        { label: 'Product', dataField: 'productName' },
        {
            label: 'Quantity', dataField: 'quantity', cellsAlign: 'right'
        },
        {
            label: 'Unit Price', dataField: 'price', cellsAlign: 'right', cellsFormat: 'c2'
        },
        {
            label: 'Last Updated', template: 'updatedDate', dataType: 'date', allowEdit: false
        },
        {
            label: 'Created', template: 'createdDate', dataType: 'date', allowEdit: false
        }
    ]
}
		
grid context menu

Custom Item

You can setup a custom menu item.
contextMenu: {
	enabled: true,
	dataSource: {
		'contextMenuItemCustom': {
			label: 'Custom Item',
			visible: true,
			command: (details) => {
				// your command code here.
			}
		}
	}
}

grid custom context menu

Binding to Context menu

If there is already a context menu on the web page, or you want to override the built-in Grid context menu, you can set the contextMenu.selector property.
const componentProps = {
    dataSourceSettings: {
        dataFields: [
            { name: 'firstName', dataType: 'string' },
            { name: 'lastName', dataType: 'string' },
            { name: 'productName', map: 'product.name', dataType: 'string' },
            { name: 'payment', map: 'product.payment', dataType: 'string' },
            { name: 'quantity', map: 'product.quantity', dataType: 'number' },
            { name: 'price', map: 'product.price', dataType: 'number' },
            { name: 'total', map: 'product.total', dataType: 'number' }
        ]
    },
    editing: {
        enabled: true
    },
    selection: {
        enabled: true,
        allowCellSelection: true,
        mode: 'extended'
    },
    contextMenu: {
        enabled: true,
        selector: "#menu"
    },
    filtering: {
        enabled: true
    },
    behavior: {
        columnResizeMode: 'growAndShrink'
    },
    sorting: {
        enabled: true
    },
    dataSource: [
        {
            firstName: 'Andrew',
            lastName: 'Burke',
            product: {
                name: 'Ice Coffee', price: 10, quantity: 3, total: 30, payment: 'Visa'
            }
        },
        {
            firstName: 'Petra',
            lastName: 'Williams',
            product: {
                name: 'Espresso', price: 7, quantity: 5, total: 35, payment: 'Visa'
            }
        },
        {
            firstName: 'Anthony',
            lastName: 'Baker',
            product: {
                name: 'Frappucino', price: 6, quantity: 4, total: 24, payment: 'Mastercard'
            }
        }
    ],
    columns: [
        {
            label: 'First Name', dataField: 'firstName'
        },
        { label: 'Last Name', dataField: 'lastName' },
        { label: 'Product', dataField: 'productName' },
        {
            label: 'Quantity', dataField: 'quantity', cellsAlign: 'right'
        },
        {
            label: 'Unit Price', dataField: 'price', cellsAlign: 'right', cellsFormat: 'c2'
        }
    ]
}
HTML for grid and menu.
<smart-grid id="grid"></smart-grid>
<smart-menu id="menu" mode="dropDown">
	<smart-menu-item data-id="Edit" label="<i class='material-icons'>edit</i>Edit"></smart-menu-item>
	<smart-menu-item data-id="Remove" label="<i class='material-icons'>delete</i> Remove"></smart-menu-item>
</smart-menu>	
and the CSS for the context menu
#menu {
    height: auto;
	width: 150px;
}

@font-face {
	font-family: 'Material Icons';
	font-style: normal;
	font-weight: 400;
	src: url(https://fonts.gstatic.com/s/materialicons/v31/2fcrYFNaTjcS6g4U3t-Y5ZjZjT5FdEJ140U2DJYC3mY.woff2) format('woff2');
}

.material-icons {
	font-family: 'Material Icons';
	font-weight: normal;
	font-style: normal;
	font-size: 20px;
	line-height: 1;
	letter-spacing: normal;
	text-transform: none;
	display: inline-block;
	white-space: nowrap;
	word-wrap: normal;
	direction: ltr;
	-webkit-font-feature-settings: 'liga';
	-webkit-font-smoothing: antialiased;
	margin-right: 10px;
}
context menu selector

Custom Context Menu

You can use a custom Menu instance as a context menu. Let's see how we can achieve that.
HTML for grid and menu.
<smart-grid id="grid"></smart-grid>
<smart-menu id="menu" mode="dropDown">
	<smart-menu-item data-id="Edit" label="<i class='material-icons'>edit</i>Edit"></smart-menu-item>
	<smart-menu-item data-id="Remove" label="<i class='material-icons'>delete</i> Remove"></smart-menu-item>
</smart-menu>	
The following code shows how to open and handle the actions of the custom menu.
const menu = document.getElementById('menu');
let rowId = null;
// disable the browser's context menu and open the custom menu.
component.value.addEventListener('contextmenu', function (event) {
	event.stopPropagation();
	event.preventDefault();
	menu.open(event.pageX, event.pageY);
	return false;
});
// handle the clicks of the custom menu.
menu.addEventListener('itemClick', function (event) {
	if (rowId === undefined) {
		return;
	}
	if (event.detail.item.getAttribute('data-id') === 'Edit') {
		component.value.beginEdit(rowId);
	}
	else {
		component.value.deleteRow(rowId);
	}
});
// disable the built-in right-click.
component.value.addEventListener('rowClick', function (event) {
	if (event.detail.originalEvent.which === 3) {
		const row = event.detail.row;
		rowId = row.id;
		event.detail.originalEvent.stopPropagation();
	}
});
grid custom context menu
For AI tooling

Developer Quick Reference

Topic: grid-context-menu   Component: Grid   Framework: Vue

Main methods: addEventListener(), beginEdit(), deleteRow()

Common config keys: editing, selection, filtering, behavior, sorting, dataSource, columns

Implementation Notes

Compatibility: Vue 3+   API access pattern: const component = ref() + component.value.method()

Lifecycle guidance: Use template refs with

Grid Context Menu

Grid for Angular

Angular standalone version of this topic (compatible with Angular 17+). Import both the Smart UI component and module in the standalone component.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { RouterOutlet } from '@angular/router';
import { GridComponent, GridModule } from 'smart-webcomponents-angular/grid';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [CommonModule, GridModule, RouterOutlet],
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css'],
  encapsulation: ViewEncapsulation.None
})
export class AppComponent {
  @ViewChild('grid', { read: GridComponent, static: false }) grid!: GridComponent;
}
<!-- app.component.html -->
<smart-grid #grid></smart-grid>

Use this.grid for API methods in this topic.

Grid Context Menu

Default Context Menu

A built-in context menu is available in the Grid component. To enable the default context menu, you can use the contextMenu property.
componentProps = {
    dataSourceSettings: {
        dataFields: [
            { name: 'firstName', dataType: 'string' },
            { name: 'lastName', dataType: 'string' },
            { name: 'productName', map: 'product.name', dataType: 'string' },
            { name: 'payment', map: 'product.payment', dataType: 'string' },
            { name: 'quantity', map: 'product.quantity', dataType: 'number' },
            { name: 'price', map: 'product.price', dataType: 'number' },
            { name: 'total', map: 'product.total', dataType: 'number' }
        ]
    },
    editing: {
        enabled: true
    },
    selection: {
        enabled: true,
        allowCellSelection: true,
        mode: 'extended'
    },
    contextMenu: {
        enabled: true
    },
    filtering: {
        enabled: true
    },
    behavior: {
        columnResizeMode: 'growAndShrink'
    },
    sorting: {
        enabled: true
    },
    dataSource: [
        {
            firstName: 'Andrew',
            lastName: 'Burke',
            product: {
                name: 'Ice Coffee', price: 10, quantity: 3, total: 30, payment: 'Visa'
            }
        },
        {
            firstName: 'Petra',
            lastName: 'Williams',
            product: {
                name: 'Espresso', price: 7, quantity: 5, total: 35, payment: 'Visa'
            }
        },
        {
            firstName: 'Anthony',
            lastName: 'Baker',
            product: {
                name: 'Frappucino', price: 6, quantity: 4, total: 24, payment: 'Mastercard'
            }
        }
    ],
    columns: [
        {
            label: 'First Name', dataField: 'firstName'
        },
        { label: 'Last Name', dataField: 'lastName' },
        { label: 'Product', dataField: 'productName' },
        {
            label: 'Quantity', dataField: 'quantity', cellsAlign: 'right'
        },
        {
            label: 'Unit Price', dataField: 'price', cellsAlign: 'right', cellsFormat: 'c2'
        },
        {
            label: 'Last Updated', template: 'updatedDate', dataType: 'date', allowEdit: false
        },
        {
            label: 'Created', template: 'createdDate', dataType: 'date', allowEdit: false
        }
    ]
}
		
grid context menu

Custom Item

You can setup a custom menu item.
contextMenu: {
	enabled: true,
	dataSource: {
		'contextMenuItemCustom': {
			label: 'Custom Item',
			visible: true,
			command: (details) => {
				// your command code here.
			}
		}
	}
}

grid custom context menu

Binding to Context menu

If there is already a context menu on the web page, or you want to override the built-in Grid context menu, you can set the contextMenu.selector property.
componentProps = {
    dataSourceSettings: {
        dataFields: [
            { name: 'firstName', dataType: 'string' },
            { name: 'lastName', dataType: 'string' },
            { name: 'productName', map: 'product.name', dataType: 'string' },
            { name: 'payment', map: 'product.payment', dataType: 'string' },
            { name: 'quantity', map: 'product.quantity', dataType: 'number' },
            { name: 'price', map: 'product.price', dataType: 'number' },
            { name: 'total', map: 'product.total', dataType: 'number' }
        ]
    },
    editing: {
        enabled: true
    },
    selection: {
        enabled: true,
        allowCellSelection: true,
        mode: 'extended'
    },
    contextMenu: {
        enabled: true,
        selector: "#menu"
    },
    filtering: {
        enabled: true
    },
    behavior: {
        columnResizeMode: 'growAndShrink'
    },
    sorting: {
        enabled: true
    },
    dataSource: [
        {
            firstName: 'Andrew',
            lastName: 'Burke',
            product: {
                name: 'Ice Coffee', price: 10, quantity: 3, total: 30, payment: 'Visa'
            }
        },
        {
            firstName: 'Petra',
            lastName: 'Williams',
            product: {
                name: 'Espresso', price: 7, quantity: 5, total: 35, payment: 'Visa'
            }
        },
        {
            firstName: 'Anthony',
            lastName: 'Baker',
            product: {
                name: 'Frappucino', price: 6, quantity: 4, total: 24, payment: 'Mastercard'
            }
        }
    ],
    columns: [
        {
            label: 'First Name', dataField: 'firstName'
        },
        { label: 'Last Name', dataField: 'lastName' },
        { label: 'Product', dataField: 'productName' },
        {
            label: 'Quantity', dataField: 'quantity', cellsAlign: 'right'
        },
        {
            label: 'Unit Price', dataField: 'price', cellsAlign: 'right', cellsFormat: 'c2'
        }
    ]
}
HTML for grid and menu.
<smart-grid id="grid"></smart-grid>
<smart-menu id="menu" mode="dropDown">
	<smart-menu-item data-id="Edit" label="<i class='material-icons'>edit</i>Edit"></smart-menu-item>
	<smart-menu-item data-id="Remove" label="<i class='material-icons'>delete</i> Remove"></smart-menu-item>
</smart-menu>	
and the CSS for the context menu
#menu {
    height: auto;
	width: 150px;
}

@font-face {
	font-family: 'Material Icons';
	font-style: normal;
	font-weight: 400;
	src: url(https://fonts.gstatic.com/s/materialicons/v31/2fcrYFNaTjcS6g4U3t-Y5ZjZjT5FdEJ140U2DJYC3mY.woff2) format('woff2');
}

.material-icons {
	font-family: 'Material Icons';
	font-weight: normal;
	font-style: normal;
	font-size: 20px;
	line-height: 1;
	letter-spacing: normal;
	text-transform: none;
	display: inline-block;
	white-space: nowrap;
	word-wrap: normal;
	direction: ltr;
	-webkit-font-feature-settings: 'liga';
	-webkit-font-smoothing: antialiased;
	margin-right: 10px;
}
context menu selector

Custom Context Menu

You can use a custom Menu instance as a context menu. Let's see how we can achieve that.
HTML for grid and menu.
<smart-grid id="grid"></smart-grid>
<smart-menu id="menu" mode="dropDown">
	<smart-menu-item data-id="Edit" label="<i class='material-icons'>edit</i>Edit"></smart-menu-item>
	<smart-menu-item data-id="Remove" label="<i class='material-icons'>delete</i> Remove"></smart-menu-item>
</smart-menu>	
The following code shows how to open and handle the actions of the custom menu.
const menu = document.getElementById('menu');
let rowId = null;
// disable the browser's context menu and open the custom menu.
this.grid.addEventListener('contextmenu', function (event) {
	event.stopPropagation();
	event.preventDefault();
	menu.open(event.pageX, event.pageY);
	return false;
});
// handle the clicks of the custom menu.
menu.addEventListener('itemClick', function (event) {
	if (rowId === undefined) {
		return;
	}
	if (event.detail.item.getAttribute('data-id') === 'Edit') {
		this.grid.beginEdit(rowId);
	}
	else {
		this.grid.deleteRow(rowId);
	}
});
// disable the built-in right-click.
this.grid.addEventListener('rowClick', function (event) {
	if (event.detail.originalEvent.which === 3) {
		const row = event.detail.row;
		rowId = row.id;
		event.detail.originalEvent.stopPropagation();
	}
});
grid custom context menu
For AI tooling

Developer Quick Reference

Topic: grid-context-menu   Component: Grid   Framework: Angular

Main methods: addEventListener(), beginEdit(), deleteRow()

Common config keys: editing, selection, filtering, behavior, sorting, dataSource, columns

Implementation Notes

Compatibility: Angular 17+ (standalone)   API access pattern: @ViewChild(...) + this.component.method()

Lifecycle guidance: Bind inputs declaratively and call imperative API through @ViewChild in/after ngAfterViewInit.

Common pitfalls:

  • Using @ViewChild API too early (before view init).
  • Omitting standalone imports for Smart modules in @Component.imports.
  • Type mismatches between configuration fields and template bindings.

Validation checklist:

  • Ensure module import exists in standalone component imports array.
  • Use typed @ViewChild(..., { read: ComponentType }).
  • Call imperative methods after view initialization.